<template>
  <input
    v-model="item"
    type="text"
    :title="title"
    :min="min"
    :max="max"
    :class="customClass"
    :name="name"
    @input="getValue"
    @blur="$emit('blur', name)"
  />
</template>

<script>
export default {
    props: {
        min: {
            type: String,
            default: '0',
        },
        max: {
            type: String,
            default: '100',
        },
        title: {
            type: String,
        },
        customClass: String,
        value: [String, Number],
        name: String
    },
    data() {
        return {
            item: '',
        }
    },
    created() {
        this.item = this.value
    },
    methods: {
        getValue() {
            const value = this.item
            this.item = [...value].filter( e => isFinite(e)).join('')
            const min = parseInt(this.min)
            const max = parseInt(this.max)
            const intItem = parseInt(this.item)

            if(this.item != ""){
                if(intItem < min) this.item = min
                else if (intItem > max) this.item = max
                this.item = parseInt(this.item).toFixed(0)
            }
            this.$emit('input', this.item)
        },
    },
}
</script>
